## aspectc++ 2.5

=== Ag++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************


# PUMA root
PUMA ?= ../Puma

# default target
TARGET  ?= linux-release

#AspectC++ source directory
AcSrcDir := ../AspectC++

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

PLATFORM := $(shell echo $(_TARGET) | cut -d _ -f1)

# determine which Puma library to use: libMiniPuma is preferred
PumaLibs := $(notdir $(wildcard $(PUMA)/lib/$(TARGET)/lib*Puma.a))
ifneq ($(filter libMiniPuma.a, $(PumaLibs)),)
	PUMA_LIB := MiniPuma
else
	PUMA_LIB := Puma
endif

#CXX  := /usr/bin/g++-3.3
#CXX := ag++  -p. -p../aspects --Xcompiler
#CXX := ag++ -v3 -p. --Xcompiler

# check whether we compile for Windows: TARGET-Variable starts with 'win'
ifneq ($(filter win%,$(TARGET)),)
	WIN := yes
endif

# compiler settings

ifeq ($(WIN),yes)
	BinExt := .exe
	RES := windres
	RCFILES := win-ag++.rc
endif

CXXFLAGS += $(CPPFLAGS) -I$(PUMA)/extern -I$(PUMA)/include -std=gnu++17

ifneq ($(PLATFORM),macos)
	ifeq ($(SHARED),)
		LDFLAGS += -static
	endif

LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)

ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif

else
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -l$(PUMA_LIB)
endif

ifneq ($(PROFILING),)
	LDFLAGS += -lc_p -lm_p 
	CXXFLAGS += -pg
endif


SourceFiles := $(wildcard *.cc) 

BuildDir ?= build/$(TARGET)

ObjDir := $(BuildDir)/obj
ObjectFiles := $(addprefix $(ObjDir)/,$(SourceFiles:%.cc=%.o))

DepDir := $(BuildDir)/dep
DepFiles := $(addprefix $(DepDir)/,$(SourceFiles:%.cc=%.d))

BinDir := $(BuildDir)/bin
BinName := ag++$(BinExt)
BinFile := $(BinDir)/$(BinName)


ifeq ($(WIN),yes)
ObjectFiles += $(addprefix $(ObjDir)/,$(RCFILES:%.rc=%.o))
DepFiles += $(addprefix $(DepDir)/,$(RCFILES:%.rc=%.d))
endif




# ******************************
# *     T A R G E T S          *
# ******************************

all: showtarget $(AcSrcDir)/bin/$(TARGET)/$(BinName)

strip: $(AcSrcDir)/bin/$(TARGET)/$(BinName)
	@$(STRIP) $<

showtarget:
	@echo "Build commands for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo 

help:
	@echo "  help:          show this help"
	@echo "  all (default): compile, link and copy"
	@echo "  copy:          copy executable into AspectC++ bin folder"
	@echo "  test :         run tests"
	@echo "  test_<XX>:     run test number <XX>"
	@echo "  doc:           build documentation"
	@echo "  showtarget:    show compiler options for selected target"
	@echo "  clean:         remove intermediate files of current TARGET"
	@echo "  distclean:     clean all generated files and directories"


clean: 
	@echo -n "CLEAN    "
	rm -rf $(BuildDir) core core.* 
	@make -C doc clean

distclean: clean
 

test:	all
	@export TARGET=$(TARGET);export EXT=$(EXT);cd tests;./run_tests.sh

test_%: all
	@export TARGET=$(TARGET);export EXT=$(EXT);cd tests; ./run_tests.sh $@

doc:
	@make -C doc


.PHONY: all clean distclean showtarget doc

# ******************************
# *       R U L E S            *
# ******************************

$(BinFile): $(ObjectFiles)
	@echo "LD        $@"
	@mkdir -p $(BinDir)
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)

$(AcSrcDir)/bin/$(TARGET)/$(BinName): $(BinFile)
	@echo "COPY      $< to $@"
	@mkdir -p $(@D)
	@cp $< $@

$(ObjDir)/%.o : %.cc
	@echo "CC        $<"
	@mkdir -p $(DepDir)
	@mkdir -p $(ObjDir)
	@$(CXX) $(CXXFLAGS) -MMD -MP -MT $@ -MT $(DepDir)/$(<:%.cc=%.d) -MF $(DepDir)/$(<:%.cc=%.d) -c -o $@ $< 
# @echo "CC        $@"
#	@mkdir -p $(ObjDir)
#	@$(CXX) $(CXXFLAGS) -c -o $@ $<

ifeq ($(WIN),yes)
$(ObjDir)/%.o : %.rc
	@echo "DEP       $@."
	@mkdir -p $(DepDir)
	@$(CXX) $(CXXFLAGS) -MM -MP -MT $@ -MT $(DepDir)/$(<:%.cc=%.d) -MF $(DepDir)/$(<:%.cc=%.d) -xc++ $< 
	@echo "RES       $@"
	@mkdir -p $(ObjDir)
	@$(RES) $(filter -D%,$(CXXFLAGS)) $< $@
endif

ifeq (,$(findstring clean,$(MAKECMDGOALS)))
ifeq (,$(findstring help,$(MAKECMDGOALS)))
-include $(DepFiles)
endif
endif

.SUFFIXES: .cc .o .h .rc .mk $(SUFFIXES)

=== AspectC++/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# AspectC++ supports alternative frontends: Puma or Clang
# It can be configured the 'make FRONTEND=...'. Default is Clang.
export FRONTEND ?= Clang

# PUMA root
PUMA    ?= ../Puma

# ACModel root
ACMODEL ?= ACModel

# LLVM config command
LLVMCONF ?= llvm-config

# libxml2 config command
XML2CONF ?= xml2-config

# default target
TARGET  ?= linux-release

# include the PUMA configuration variables
# => set _TARGET, RELEASE, CFLAGS, CXXFLAGS, CPPFLAGS, etc.
include $(PUMA)/vars.mk

PLATFORM := $(shell echo $(_TARGET) | cut -d _ -f1)
ARCH := $(shell echo $(_TARGET) | cut -d _ -f2-)

# check whether we compile for Windows: TARGET-Variable starts with 'win'
ifneq ($(filter win%,$(TARGET)),)
	WIN := yes
	EXT := .exe
endif

# libxml2 settings
LIBXML2_INC := $(shell $(XML2CONF) --cflags)
ifeq ($(PLATFORM),macos)
  # Don't mess up the compiler's include hierarchy
  SDKROOT := $(shell xcrun --show-sdk-path)
  LIBXML2_INC := $(filterout -I$(SDKROOT)/usr/include, $(LIBXML2_INC))
endif
LIBXML2_INC := $(patsubst -I/%, -isystem /%, $(LIBXML2_INC))
LIBXML2_LIB := $(shell $(XML2CONF) --libs)

# Check Clang version and define all necessary symbols (LLVM_*)
ifneq ($(MAKECMDGOALS),clean)
  ifeq ($(FRONTEND),Clang)
    include config/clang.mk
  endif
endif

# linker settings
export SHARED # if defined, sub-makes should see this setting, too

ifneq ($(PLATFORM),macos)
ifeq ($(SHARED),)
  LDFLAGS += -static
endif
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -Wl,-Bstatic -L$(PUMA)/lib/$(TARGET) -lPuma 
ifneq ($(SHARED),)
	LDFLAGS += -Wl,-Bdynamic
endif
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma 
ifneq ($(SHARED),)
	LDFLAGS += #-Wl,-Bdynamic
endif
endif
else
ifeq ($(FRONTEND),Puma)
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lPuma
else # FRONTEND is Clang
	LDFLAGS += -L$(PUMA)/lib/$(TARGET) -lMiniPuma
endif
endif

LDFLAGS += $(LIBXML2_LIB)
ifneq ($(FRONTEND),Puma)
  LDFLAGS += -lclangRewriteFrontend -lclangRewrite -lclangFrontend -lclangSerialization -lclangDriver -lclangParse -lclangSema -lclangAnalysis -lclangEdit -lclangAST -lclangLex -lclangBasic -lLLVMAsmParser -lLLVMMCParser -lLLVMBitReader -lLLVMTransformUtils -lLLVMCore -lLLVMMC -lLLVMOption -lLLVMSupport
  ifeq ($(filter-out 18.1.3 18.1.8 19.1.6 20.1.2 21.1.6, $(shell $(LLVMCONF) --version)),)
    LDFLAGS += -lclangAPINotes -lclangSupport -lclangASTMatchers -lclangBasic # extra libs for clang-18/19
  endif
ifneq ($(PLATFORM),macos)
  # On the ARMEL platform we also need -latomic. This is a workaround for a gcc bug.
  LDFLAGS += -Wl,--as-needed -latomic -Wl,--no-as-needed
  # ... until here
#  LDFLAGS += `$(LLVMCONF) --libs`
  LDFLAGS += $(patsubst %,-Xlinker --wrap=%,$(LLVM_SYMBOLS))
else
# Mac OS X is special, we patch the clang libraries below.
  LDFLAGS := libclangSema.o $(filter-out -lclangSema, $(LDFLAGS))
endif
LDFLAGS += `$(LLVMCONF) --ldflags`
# - Additional libraries ("--libs") needed
# - Starting with 4.0 "--system-libs" returns nothing if the debian clang package is used. "--link-static" forces
#   "--system-libs" to return the system libs in all cases
LDFLAGS += $(shell $(LLVMCONF) --libs --system-libs --link-static)

# On Windows (MinGW) fix the linker flags; llvm-config is not perfect
# 1. replace libzstd.dll.a with a normal -l
# 2. add -lversion
ifeq ($(WIN),yes)
  LDFLAGS := $(patsubst %/libzstd.dll.a, -lzstd, $(LDFLAGS)) -lversion
endif

# workaround for strange MacOS config from clang                                                                                    
ifeq ($(PLATFORM),macos)
LDFLAGS := $(filter-out -llibxml2.tbd, $(LDFLAGS))
endif
endif

# compiler settings
ifeq ($(WIN),yes)
  RES := windres
  RCFILES := win-ac++.rc
  ifeq ($(SHARED),)
     CPPFLAGS += -DLIBXML_STATIC # the MinGW libxml2 requires this; otherwise linker problems
  endif
endif

CPPFLAGS += -I$(PUMA)/extern -I$(PUMA)/include $(LIBXML2_INC)
ifeq ($(FRONTEND),Puma)
  CPPFLAGS += -DFRONTEND_PUMA
else
  FILTEROUT :=
ifeq ($(RELEASE),debug)
  # filter-out "-DNDEBUG" added by LLVMCONF, if LLVM is in built in release-mode
  FILTEROUT := -DNDEBUG
endif
  LLVM_CPPFLAGS := $(shell $(LLVMCONF) --cppflags)
  ifeq ($(WIN),yes)
    # llvm-config on Windows generates path name with '\' that mingw g++ can't handle properly
    LLVM_CPPFLAGS := $(subst \,/,$(LLVM_CPPFLAGS))
  endif
  LLVM_CPPFLAGS := $(patsubst -I/%, -isystem /%, $(LLVM_CPPFLAGS))
  CPPFLAGS += $(filter-out $(FILTEROUT),$(LLVM_CPPFLAGS))
  CPPFLAGS += -DFRONTEND_CLANG
  CXXFLAGS += -fno-rtti -Wno-strict-aliasing -Wno-nonnull # hide annoying warnings in Clang headers
  # Clang >= 11 uses C++14 features; "c++14" does not work -> WIN32 not defined on Windows!
  # clang >= 18 requires C++17
  CXXFLAGS += -std=gnu++17 
endif

# profiling
ifneq ($(GPROF),)
	LDFLAGS := $(LDFLAGS) -lc_p -lm_p 
	CXXFLAGS += -pg
endif

ifneq ($(PROFILING),)
	CPPFLAGS += -DPROFILING
endif

# use libacmodel
LDFLAGS  += -L$(ACMODEL)/lib/$(TARGET) -lacmodel 
ACMODELLIB := $(ACMODEL)/lib/$(TARGET)/libacmodel.a

# ******************************
# *       S O U R C E S        *
# ******************************

BINDIR := bin/$(TARGET)

#programm to compile
PROG := $(BINDIR)/ac++$(EXT)

# sources; front-end specific files for the wrong frontend are filtered out
CCSOURCES := $(wildcard *.cc)
ifeq ($(FRONTEND),Puma)
CCSOURCES := $(filter-out Clang%.cc, $(CCSOURCES))
else
CLANG_PATCHED_SOURCES := $(filter Clang-$(LLVM_VERSION)-%.cc, $(CCSOURCES))
CCSOURCES := $(filter-out Puma%.cc, $(CCSOURCES))
CCSOURCES := $(filter-out Clang-%.cc, $(CCSOURCES)) $(CLANG_PATCHED_SOURCES)
endif

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o) $(RCFILES:.rc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))
# dependency file generation flags for g++; note that "=" is used instead of ":="
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$*.d
DEPFLAGS_SHOW := -MT <file.o> -MMD -MP -MF <file.d>

CONFIGDIR := config

DIRS := $(OBJECTDIR) $(DEPDIR) $(BINDIR)

# ******************************
# *  E X A M P L E  / T E S T  *
# ******************************

# tool selection
export AC := $(shell pwd)/$(PROG)
export AG := $(shell pwd)/$(BINDIR)/ag++$(EXT)

MAKE ?= make

# ac++ settings for tests
ACFLAGS := -k -v 9

ACEXAMPLES = coverage helloworld modules profiling singleton threads


.PHONY: $(ACEXAMPLES) 


# ******************************
# *      T A R G E T S         *
# ******************************

define _show_target
	@echo "---"
	@echo "Making AspectC++ for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(DEPFLAGS_SHOW) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "  Linker   = $(CXX) $(CXXFLAGS) <objects> $(LDFLAGS)"
	@echo "---"
endef

all:
	@$(MAKE) -C ACModel
	@$(call _show_target)
	@$(MAKE) $(PROG)

#.NOTPARALLEL: all

strip: $(PROG)
	@$(STRIP) $<

showtarget:
	@$(call _show_target)

clean:  testclean exampleclean
	@$(MAKE) -C ACModel clean
	@echo Making it clean.
	@rm -rf  core core.* *~ $(PROG) $(OBJECTDIR) $(DEPDIR) $(ERROR_FILE)

cleanall:	doxygen-clean clean

test: $(PROG) testall

example: $(PROG) $(addsuffix .example_make, $(ACEXAMPLES))

examplerun: example $(addsuffix .example_run, $(ACEXAMPLES))

exampleclean:
	@rm -rf examples/*-out
	@rm -rf examples/*.acp
	@rm -rf examples/*.acp.lock

doxygen:
	@echo "Making AspectC++ documentation with doxygen"
	@doxygen doc/doxygen.conf && echo "=> see doc/doxygen/html/index.html"

doxygen-clean:
	@rm -rf doc/doxygen

.PHONY: all strip showtarget \
		test clean cleanall example examplerun exampleclean \
        doxygen doxygen-clean

# ******************************
# *       R U L E S            *
# ******************************

$(DIRS) :
	@mkdir -p $@

$(PROG): $(OBJECTS) $(ACMODELLIB)
# For clang on macOS we create relinked objects with the patched symbols.
ifneq ($(FRONTEND),Puma)
ifeq ($(PLATFORM),macos)
	@echo "Creating patched clang libraries ..."
	@$(LD) -arch $(ARCH) -r `$(LLVMCONF) --libdir`/libclangSema.a -o libclangSema.o -all_load \
          -macos_version_min $(shell otool -l `$(LLVMCONF) --libdir`/libclangSema.a | grep minos | sort -n | head -1 | cut -f3 -w) \
          $(foreach SYM, $(LLVM_SYMBOLS_SEMA), -alias $(SYM) ___real$(SYM) -unexported_symbol $(SYM))
endif
endif
	@echo "Linking $@."
	@mkdir -p $(BINDIR)
	@$(CXX) -o $@ $(CXXFLAGS) $^ $(LDFLAGS)

$(OBJECTDIR)/%.o : %.cc
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR) $(DEPDIR)
	@$(CXX) $(DEPFLAGS) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

# -Wold-style-cast to find classic C casts "a = (A*)b;"

ifeq ($(WIN),yes)
$(OBJECTDIR)/%.o : %.rc
	@echo Compiling Windows resource file
	@mkdir -p $(OBJECTDIR)
	@$(RES) $(filter -D%,$(CPPFLAGS)) $< $@

endif

test%: 
	$(MAKE) -C tests -s  $*

%.example_make: %
	cd examples/$< ; \
	$(AC) $(ACFLAGS) -I. -p . -d ../$<-out \
	-r ../$<.acp ; \
	cp Makefile ../$<-out/Makefile; \
	cd ../$<-out; g++ -o $< *.cc -lpthread

%.example_run:	%.example_make
	@echo ""
	@echo ---- Running $* ----
	@cd examples/$*-out; `find . -type f -perm -700`

include $(wildcard $(DEPS))

=== AspectC++/ACModel/Makefile ===
# ******************************
# *       S E T T I N G S      *
# ******************************

# default target
TARGET  ?= linux-release
ifeq ($(filter %-release,$(TARGET)),)
RELEASE := debug
else
RELEASE := release
endif

# check whether we compile for Windows: TARGET-Variable starts with 'win'
ifneq ($(filter win%,$(TARGET)),)
	WIN := yes
endif

# libxml2 settings
XML2CONF ?= xml2-config
LIBXML2_INC := $(shell $(XML2CONF) --cflags)
ifneq ($(filter macos%,$(TARGET)),)
  # Don't mess up the compiler's include hierarchy
  SDKROOT := $(shell xcrun --show-sdk-path)
  LIBXML2_INC := $(filterout -I$(SDKROOT)/usr/include, $(LIBXML2_INC))
endif
LIBXML2_INC := $(patsubst -I/%, -isystem /%, $(LIBXML2_INC))

# compiler setting
ifeq ($(RELEASE),debug)
CFLAGS := -O0 -ggdb3 -fno-inline -fno-default-inline
else
CFLAGS   ?= -O2 -ggdb3
CPPFLAGS += -DNDEBUG
endif
CFLAGS   += -Wall -pipe
CXXFLAGS += $(EXTERNAL_CFLAGS) $(CFLAGS) -std=gnu++17 # -fno-rtti -fno-exceptions

CPPFLAGS += $(LIBXML2_INC)
ifeq ($(WIN),yes)
  ifeq ($(SHARED),)
     CPPFLAGS += -DLIBXML_STATIC # the MinGW libxml2 requires this; otherwise linker problems
  endif
endif

ifneq ($(COMPILE_TARGET),)
CFLAGS += -target $(COMPILE_TARGET)
endif

# ******************************
# *       S O U R C E S        *
# ******************************

# library file
LIBDIR := lib/$(TARGET)
LIB := $(LIBDIR)/libacmodel.a

CCSOURCES := $(wildcard *.cc) 

OBJECTDIR := ObjFiles/$(TARGET)
OBJECTS := $(addprefix $(OBJECTDIR)/,$(CCSOURCES:.cc=.o))

DEPDIR := DepFiles/$(TARGET)
DEPS := $(addprefix $(DEPDIR)/,$(CCSOURCES:.cc=.d))
# dependency file generation flags for g++; note that "=" is used instead of ":="
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$*.d
DEPFLAGS_SHOW := -MT <file.o> -MMD -MP -MF <file.d>

DIRS := $(OBJECTDIR) $(DEPDIR) $(LIBDIR)

# ******************************
# *      T A R G E T S         *
# ******************************

define _show_target
	@echo "---"
	@echo "Making ACModel library for TARGET=$(TARGET)"
	@echo "  Compiler = $(CXX) $(DEPFLAGS_SHOW) $(CPPFLAGS) $(CXXFLAGS)"
	@echo "---"
endef

all:
	@$(call _show_target)
	@$(MAKE) $(LIB)

showtarget:
	@$(call _show_target)

clean:
	@echo Cleaning ACModel.
	@rm -rf core core.* *~ lib DepFiles ObjFiles

# ******************************
# *       R U L E S            *
# ******************************

$(LIB): $(OBJECTS) 
	@echo "Creating library $@."
	@mkdir -p $(LIBDIR)
	@$(AR) rcs $@  $(OBJECTS)

$(OBJECTDIR)/%.o : %.cc 
	@echo Making object file $@.
	@mkdir -p $(OBJECTDIR) $(DEPDIR)
	@$(CXX) $(DEPFLAGS) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

include $(wildcard $(DEPS))

.phony: all clean showtarget

=== AspectC++/doc/Makefile ===
LYXFILES := ac-compilerman.lyx ac-languageref.lyx ac-firststeps.lyx
DIRS := CompilerManual LanguageReference FirstSteps
PDFFILES := $(patsubst %.lyx,gen/%.pdf,$(LYXFILES))
XHTMLFILES := $(patsubst %.lyx,gen/%.xhtml,$(LYXFILES))

VPATH = CompilerManual:LanguageReference:FirstSteps

all: $(PDFFILES) $(XHTMLFILES)

gen/%.pdf: %.lyx ac-manual.layout
	@echo Exporting $@
	@lyx -E pdf2 $@ $< > gen/logpdf.txt

gen/%.xhtml: %.lyx ac-manual.layout
	@echo Exporting $@
	@lyx -E xhtml $@ $< > gen/logxhtml.txt
	@echo Transforming export file: step 1
	@xsltproc gen/fixhtml1.xsl $@ > $@.trans1
	@echo Transforming export file: step 2
	@xsltproc --novalid gen/fixhtml2.xsl $@.trans1 > $@.trans2
	@cp $@.trans2 $@
	@rm $@.trans*
	@echo Renaming SVGs
	@cd gen; for f in `find . -name "e_*.svg"`; do n=`echo $$f | cut -d _ -f3-` ; echo "  $$f -> img_$$n"; mv $$f img_$$n; done

clean:
	@rm -rf $(PDFFILES) $(XHTMLFILES) gen/log*.txt gen/*~ gen/img_*.svg gen/*.trans*

=== AspectC++/tests/Makefile ===
ifeq ($(REGRESSIONTEST),1)
MAKELEVEL := 1
endif

ifeq ($(MAKELEVEL),0)
$(error Sorry, this makefile is not intended to be \
used directly. Please use the makefile in the toplevel \
directory of the AspectC++ source tree instead)
endif

SHELL=/bin/bash
DIFF=diff --strip-trailing-cr

ACTESTS = Advice AdviceVirtualFct That StaticTrace Context NameMangling \
          Forward StandAloneCalls UnknownTypeCheck AccessControl Result \
          ArrayMangling MatchExpr ConsDesAdvice NestedClassFuncAdvice \
          MacroCall CallAdvice CallOnRef TemplateExtCall Bug190 Bug191 Bug192 \
	  Order NonInlineIntros JPType PragmaOnce Bug207 \
	  AbstractDerivedAspect PragmaOnceObserver ThatConst PrivateResult \
          VoidArg ArrayWrapper Bug216 Bug228 ExecAdviceRecursive ExternC \
	  ThatContext IntroIncludes Bug234 Bug234-2 Bug235 Bug239 \
	  ExecAdviceNewDelete ExecAdviceFriend CallPostfixOp \
	  CFlowCycle Bug368 Bug179 RightlessCalls Bug477 \
	  IntroInBase Bug267 Bug268 Bug271 MatchVirtual \
	  PctInClass IntroInAll Instantiation Slice NonInlineSliceInclude \
	  Empty Bug316 Derived Base Bug323 GlobalIds AnonymousStuff \
	  ForcedInclude Bug336 Bug353 Introspection CallAccess Bug418 Bug209 \
          MatchStatic Bug512 SliceJPAPI JPTL NamedPointcuts AspectPrivileges \
	  RepoInvalid RepoVersion Bug321 Bug484 Bug524 DisjointIds AspectOf \
	  MemberPointCut MatchScopeWithin \
	  Bug549 Bug552 Bug554 DefaultArgs Bug561 Bug564 Bug566 Bug570 \
	  Bug571-1 Bug571-2 Bug571-3 Bug575 Bug577 Bug427 AttribAligned \
      VirtualPointcuts Bug580 MacroExpansion Bug768 Bug769 Bug770 Bug772 \
      Bug781 Bug784 BugUsingAttribute Bug796 OrderDerived Bug798 Bug777 \
	  Bug801 PragmaAcxxAffect

ifeq ($(FRONTEND),Clang)
ACTESTS += DataFlowAnalysis
ACTESTS += CallBuiltinOperator MemberPointCut2
ACTESTS += SimpleGetAdvice SimpleSetAdvice CompoundGetSetAdvice FunctionEntity \
           SimpleRefAdvice SimpleAliasAccessMember SimpleGetSetFuncPtr \
           ArrayAccessAdvice MatchScope GetBaseDerived \
           Bug-Typenames DefaultArgs2 CallViaADN Bug574 GetConditional Bug576 \
           Bug567 Bug568 Bug548 Bug589 Bug594 Bug598 CallRef \
           EntityInfo VolatileResult Bug792 BugAttribInConstexpr StdCxx17 \
           DivByZero StdCxx11 STLString
ACTESTS += Attribute_basic Attribute_inMacro Attribute_removeAttrs
		   #Attribute_pointcuts Attribute_params Attribute_paramEvaluation \
		   #Attribute_paramsIntrospection Attribute_stringParam
# TypePrinting_FunctionPointers <-- waiting for clang improvement
ifneq ($(shell uname -s),Darwin)
ACTESTS += Float128Basic
endif

endif

# disabled: UnsizedArray
# to be removed: NonInlineIntroInclude
# (uses deprecated introduction syntax massively)

ACMSGTESTS := RepoInvalid RepoVersion Bug570 PragmaAcxxAffect

ACNORUN := $(filter $(ACMSGTESTS), $(ACTESTS))

ACRUN   := $(filter-out $(ACNORUN), $(ACTESTS))

STDOUT_FILE := stdout.txt
STDERR_FILE := stderr.txt
ERROR_FILE :=  error.txt

# ***** The following is only used for the Akut testsystem (REGRESSIONTEST == 1) *****
# ====================================================================================
ifeq ($(REGRESSIONTEST),1)

define do_test_start
    @COUNT=0;PASS=0;FAIL=0;
endef

define do_test_weave
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(1)/feature.out; \
	exec 2> $(1)/feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $(1)/feature.err $(1)/feature.out; \
	rm $(1)/feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_run
	COUNT=$$(($$COUNT+1)); \
	echo ---START TEST $$COUNT: $1: is expected to PASS; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $(1) ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $(1) diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo ---END TEST $$COUNT: $1: PASS \(was expected to pass and did pass\); \
		PASS=$$(($$PASS+1)); \
	else \
		cat $(STDOUT_FILE) ;\
		cat $(STDERR_FILE) ;\
		FAIL=$$(($$FAIL+1)); \
		echo ---END TEST $$COUNT: $1: FAIL \(was expected to pass, but failed\); \
	fi;
endef

define do_test_end
	echo -n "---EXECUTIVE SUMMARY: " ;\
	if [ $$FAIL -eq $$COUNT ]; then\
		echo FAIL \(all tests failed\) ;\
	elif [ $$FAIL -gt 0 ]; then \
		echo PARTLY \($$(( $$PASS * 100 / $$COUNT ))% tests passed as expected\); \
	else \
		echo PASS \(all tests passed\) ;\
	fi ;\
	echo ---START SUMMARY; \
	echo $$COUNT tests in this testcase; \
	echo $$PASS tests passed as expected; \
	echo $$FAIL tests did not pass as expected; \
	echo $$FAIL expected to pass but failed; \
	echo 0 expected to fail but passed; \
	echo ---END SUMMARY
endef

regression_test:
	$(call do_test_start) \
	$(foreach T, $(ACRUN), $(call do_test_run, $(T))) \
	$(foreach T, $(ACNORUN), $(call do_test_weave, $(T))) \
	$(call do_test_end)

endif

# ================================================================================
# ***** The above is only used for the Akut testsystem (REGRESSIONTEST == 1) *****


all: $(addsuffix .make, $(ACRUN)) $(addsuffix .weave, $(ACNORUN))
	@if [ -f $(ERROR_FILE) ];then \
		echo -e "\n\n"; \
		echo "+---------+"; \
		echo "|ERRORS:  |"; \
		echo "+---------+"; \
		cat $(ERROR_FILE); \
		rm -f $(STDOUT_FILE) $(STDERR_FILE) $(ERROR_FILE); \
		exit 1; \
	 else \
		echo -e "\n\n"; \
	 	echo "All tests OK"; \
	 	rm -f $(STDOUT_FILE) $(STDERR_FILE); \
	 fi;\

ref:  $(addsuffix .ref, $(ACTESTS))

refclean:
	rm */feature.ref

run: $(addsuffix .run, $(ACRUN))

clean: $(addsuffix .clean, $(ACTESTS))


%.weave: %
	@unset LANG; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $</feature.out; \
	exec 2> $</feature.err; \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	cp $</feature.err $</feature.out; \
	rm $</feature.err; \
	exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< diff-only; \
	RET=$$?; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
		ERR_FLAG=D; \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;


%.make: %
	@exec 6>&1; \
	exec 7>&2; \
	exec > $(STDOUT_FILE); \
	exec 2> $(STDERR_FILE); \
	$(MAKE) -s EXT="$(EXT)" -C $< ; \
	RET=$$?; \
	ERR_FLAG=C; \
	if [ $$RET == 0 ];then \
	 	$(MAKE) -s EXT="$(EXT)" -C $< diff; \
	 	RET=$$?; \
		ERR_FLAG=D; \
	fi; \
	exec 1>&6 6>&-; \
	exec 2>&7 7>&-; \
	if [ $$RET == 0 ];then \
		echo -n "."; \
	else \
	 	echo -n "[$$ERR_FLAG:$<]"; \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo  -n "TEST: $<" >> $(ERROR_FILE); \
		echo -ne "\n-----------------------------------------------------------------------------\n" >> $(ERROR_FILE); \
		echo -e "STDOUT:\n--------" >> $(ERROR_FILE); \
		cat $(STDOUT_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
		echo -e "STDERR:\n--------" >> $(ERROR_FILE); \
		cat $(STDERR_FILE) >> $(ERROR_FILE); \
		echo   >> $(ERROR_FILE); \
	fi;




%.ref: %
	$(MAKE) -s EXT="$(EXT)" -C $< ref; 

%.run:	%
	@echo Making and running test '$<'
	cd $< && $(MAKE) run

%.clean: %
	cd $< && $(MAKE) clean

.PHONY: all clean run ref

=== AspectC++/tests/Attribute_basic/Makefile ===
ACFLAGS ?= --data_joinpoints --builtin_operators
CXXFLAGS ?= -std=c++17
include ../Makefile.generic

=== AspectC++/tests/ExecAdviceNewDelete/Makefile ===
AC_PATTERN_REPLACEMENTS := | sed -e "s/new(.*)/new(<<<replaced>>>)/" | sed -e "s/new\[\](.*)/new[](<<<replaced>>>)/" | sed -e "s/void \*,.*)/void \*)/"
include ../Makefile.generic

=== AspectC++/tests/PragmaAcxxAffect/Makefile ===
WEAVE_ERROR := 1
AC_PATTERN_REPLACEMENTS := | sed -e 's/.*\/tests\/PragmaAcxxAffect\///'
include ../Makefile.generic

=== debian/changelog ===
aspectc++ (1:2.5-1) unstable; urgency=medium

  * New upstream version 2.5, Closes: #1120401, #1096333

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 29 Dec 2025 17:06:43 -0500

=== debian/control ===
Source: aspectc++
Section: devel
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper (>= 10), pkgconf, libxml2-dev, docbook-to-man, zlib1g-dev, libedit-dev, llvm-21-dev, libclang-21-dev, libpolly-21-dev, libzstd-dev
Build-Depends-Indep: doxygen, graphviz, gsfonts
Standards-Version: 4.7.0
Homepage: http://www.aspectc.org
Vcs-Git: https://salsa.debian.org/debian/aspectc.git
Vcs-Browser: https://salsa.debian.org/debian/aspectc

Package: aspectc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: aspect-oriented programming extension for C++
 AspectC++ supports Aspect-Oriented Programming with C++, by providing:
 .
  - an aspect language extension to C++.
  - an aspect weaver that does source-to-source translation.
 .
 AspectC++ provides for C++ similar features like its best known
 cousin, AspectJ, provides for Java.

Package: libpuma-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Suggests: libpuma-doc
Description: C/C++/AspectC++ Scanner and Parsers (development headers)
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships a static copy of libPuma only.

Package: libpuma-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: C/C++/AspectC++ Scanner and Parsers (documentation)
 libPuma is a library written in C++ for Scanning and Parsing C++
 Code. It also does some semantic analysis.
 .
 It was written to facilitate the development for tools, which manipulate
 and/or transfor C/C++ Code.
 .
 This package ships doxygen generated documentation for Puma.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# disable parallelism inside this makefile (but not submakes)
.NOTPARALLEL:

# Support multiple makes at once
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS := 1
# on i386 and amd64, we query the system unless overriden by DEB_BUILD_OPTIONS
ifeq      ($(DEB_HOST_ARCH),i386)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
else ifeq ($(DEB_HOST_ARCH),amd64)
NUMJOBS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
endif
endif

# workaround for bug #701244 - aspectc++ supports __int128 by default
# only when woven on 64bits, which the upstream provided sources don't.
AC_OPTFLAGS = --gnu-int128
export AC_OPTFLAGS

# we seem to have locking issues on kFreeBSD. force single threaded
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
NUMJOBS := 1
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS := -O0 -g
else
	CFLAGS := -O2 -g
endif

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq  (,$(filter $(DEB_BUILD_ARCH),armel armhf))
# fatal: Caught standard exception: deque::_M_new_elements_at_back
	CFLAGS := -O1 -g
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	CFLAGS += -fPIC
endif

export CFLAGS
PUMA_CONFIG=$(CURDIR)/puma.config

test-builds: build-arch-stamp
	AspectC++/bin/linux-release/ag++ --gen_config
	echo '-D "__cplusplus=199711L"' >> $(PUMA_CONFIG)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	-$(MAKE) -C AspectC++ PUMA_CONFIG=$(PUMA_CONFIG) FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-21 SHARED=1 AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" REGRESSIONTEST=1 examples test
	PATH=$(CURDIR)/AspectC++/bin/linux-release:$(PATH) \
	$(MAKE) -C Ag++/ SHARED=1 PUMA_CONFIG=$(PUMA_CONFIG) test

endif

build: build-arch build-indep

build-arch: build-arch-stamp test-builds
build-arch-stamp:
	dh_testdir
	cp -v AspectC++/config/clang-21.1.6.mk AspectC++/config/clang-$(shell llvm-config-21 --version).mk
	$(MAKE) -C Puma/ MINI=1        -j$(NUMJOBS) all
	$(MAKE) -C AspectC++/ SHARED=1 -j$(NUMJOBS) all FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-21
	$(MAKE) -C Ag++/      SHARED=1 -j$(NUMJOBS) all
	# ok, now we have both an ac++ binary and ag++ binary now let's
	# weave Puma again in the copy
	$(MAKE) -C Puma clean
	# allow weaving Puma to fail, cf. #1070443
	-$(MAKE) -C Puma all AC="$(CURDIR)/AspectC++/bin/linux-release/ac++" -j$(NUMJOBS) EXTENSIONS="acppext gnuext winext"
	# build manpages:
	docbook-to-man debian/ac++.1.sgml > ac++.1
	docbook-to-man debian/ag++.1.sgml > ag++.1
	# mark timestamp
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir
	$(MAKE) -C Puma doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	dh_clean build-*stamp binary-*stamp puma.config
	cp -v AspectC++/config/clang-21.1.6.mk AspectC++/config/clang-$(shell llvm-config-21 --version).mk
	# cleaning up source directories:
	$(MAKE) -s -C Puma cleanall
	# The clang frontend adds additional tests that need cleaning
	# so far, no tests are excluded by using the Clang frontend
	$(MAKE) -s -C AspectC++ cleanall FRONTEND=Clang LLVMCONF=/usr/bin/llvm-config-21
	$(MAKE) -s -C Ag++ clean
	# remove leftovers from Upstream Makefiles
	rm -rf Puma/include
	rm -rf AspectC++/tests/RepoVersion/repo.use
	rm -rf Ag++/DepFiles Ag++/ObjFiles Ag++/bin Ag++/tests/test_11.config
	rm -rf AspectC++/DepFiles AspectC++/ObjFiles AspectC++/bin
	rm -rf AspectC++/tests/*/feature.out
	rm -rf AspectC++/tests/RepoVersion/feature.fil
	# remove generated manpages:
	rm -f ac++.1 ag++.1
	rm -rf AspectC++/bin
	rm -rf Puma.copy/
	# remove autopkgtest cruft
	rm -rf Ag++/tests/src/obj
	rm -rf Ag++/tests/src/test
	rm -fv AspectC++/config/clang-$(shell llvm-config-21 --version).mk
	# standard cleaning:
	dh_clean

# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installchangelogs
	dh_installdocs -p libpuma-doc Puma/doc/RefMan/html
	dh_installexamples -p libpuma-doc Puma/examples/*
	dh_compress -X.cc -X.map
	dh_fixperms
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_installchangelogs
	dh_installdocs
	dh_install -Xlicence_1_0.txt
	dh_installexamples -p aspectc++ AspectC++/examples/*
	find debian/aspectc++ -name Makefile -exec rm -v {} +
	find debian/libpuma-doc -name Makefile -exec rm -v {} +
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary
